if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_allypage) eu.galaxytool.GTPlugin_allypage={};

eu.galaxytool.GTPlugin_allypage = {
	
	get_alliance_data: function(docroot) {
		try {
	        try {
	        rows = docroot.getElementById("member-list").getElementsByTagName("tbody")[0].rows;
	        } catch(no_error) {
	        	// eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "unexpected error: "+no_error);
	        	// no alliance table found - player is not part of any alliance
	        	return [false,false];
	        }
	        

	        var tmp;
	        var playername = new Array(rows.length-1);
	        var ogame_playerid = new Array(rows.length-1);
	        var score = new Array(rows.length-1);
	        var ranks = new Array(rows.length-1);
	        var galaxies = new Array(rows.length-1);
	        var systems = new Array(rows.length-1);
	        var planets = new Array(rows.length-1);
	        
	        var j = 0;
	       	
	        for(i = 0; i < rows.length; i++) { 
	        	try {
	            	playername[j]     = rows[i].getElementsByTagName("td")[0].innerHTML;
	            	playername[j]     = eu.galaxytool.GTPlugin_general.trimString(playername[j]);
	            	score[j]          = parseInt(rows[i].getElementsByTagName("td")[3].getElementsByTagName("span")[0].getAttributeNode("title").value.replace(/\.|\,|\|/g,""));
	            	ranks[j]		  = parseInt(rows[i].getElementsByTagName("td")[3].getElementsByTagName("span")[0].innerHTML);
	            	galaxies[j]		  = parseInt(rows[i].getElementsByTagName("td")[4].getElementsByTagName("a")[0].innerHTML.match(/\[(\d+)\:/)[1])
	            	systems[j]		  = parseInt(rows[i].getElementsByTagName("td")[4].getElementsByTagName("a")[0].innerHTML.match(/\:(\d+)\:/)[1])
	            	planets[j]		  = parseInt(rows[i].getElementsByTagName("td")[4].getElementsByTagName("a")[0].innerHTML.match(/\:(\d+)\]/)[1])
	            	// there are two buttons, therefore also more "td"s, one for kick, and the second for sending a message
	            	ogame_playerid[j] = rows[i].getElementsByTagName("td")[6].getElementsByTagName("a")[1].getAttributeNode("href").value.match(/to\=(\d+)/)[1];
	            	//alert("no-online+kick");
	        	} catch(no_error) {
	        		try {
	        			// there is only one Button (send message) - the player has no rights to kick someone
	        			ogame_playerid[j] = rows[i].getElementsByTagName("td")[6].getElementsByTagName("a")[0].getAttributeNode("href").value.match(/to\=(\d+)/)[1];
	        			//alert("no-online+no-kick");
	        		} catch (no_error2) {
	        			try {
	        				//the button is in the 8th td, he is allowed to see online time and has the right to kick someone
	        				ogame_playerid[j] = rows[i].getElementsByTagName("td")[7].getElementsByTagName("a")[1].getAttributeNode("href").value.match(/to\=(\d+)/)[1];
	        				//alert("online+kick");
	        			} catch(no_error3) {
	        				try {
	        					//the button is in the 8th td, he is allowed to see online time but he is not allowed to kick someone
	        					ogame_playerid[j] = rows[i].getElementsByTagName("td")[7].getElementsByTagName("a")[0].getAttributeNode("href").value.match(/to\=(\d+)/)[1];
	        					//alert("online+no-kick");
	        				} catch(no_error4) {
	        	       			ogame_playerid[j] = 0;
	        	       			//alert("self");
	        				}
	        			}
	        		}
	        	}
	        	j++;
	        }
	        
	        var allytag = docroot.getElementById("allyData").getElementsByTagName("tbody")[0].getElementsByTagName("span")[1].innerHTML;
			
			//old result
		    var data = "";
		    data += "&playername=" + playername.join("|");
		    data += "&ogame_playerid=" + ogame_playerid.join("|");
		    data += "&score=" + score.join("|");
		    
		    var alliance_data_xml = '	<allypage_header name="'+allytag+'"/>'+'\n';
		    for (i = 0; i < playername.length; i++) {
		    	alliance_data_xml += '	<player rank="'+ranks[i]+'" playername="'+playername[i]+'" playerid="'+ogame_playerid[i]
		    						+'" galaxy="'+galaxies[i]+'" system="'+systems[i]
		    						+'" planet="'+planets[i]+'" score="'+score[i]+'"/>'+'\n';
		    }
		    
			return [data,alliance_data_xml];
			
			
		} catch(e) {
			eu.galaxytool.GTPlugin_general.set_status(eu.galaxytool.GTPlugin_general.Messagedoc, "galaxyplugin"+1 , 0, "unexpected error: "+e);
			return [false,false];
		}
	},
	
	submit_allydata: function(e) {
			
			var id = e.relatedNode.getAttributeNode("id").value;
			if (id != "eins") {
				return;
			}
			try {
				if (e.target.innerHTML.indexOf('id="member-list"') == -1) {
					// we need at least the member-list
					return;
				}
			} catch(error) {
				return;
			}
			// now we found HTML content that contained the ID
			
			doc = eu.galaxytool.GTPlugin_general.Messagedoc;

			// reset status window content from any previous transmission
			try {
				eu.galaxytool.GTPlugin_general.clear_status(doc);
			} catch(e) {
				alert("error: "+e);
			}
			
			eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, "Alliance page found");
	        var alliance_text,alliance_text_xml;
	        [alliance_text,alliance_text_xml] = eu.galaxytool.GTPlugin_allypage.get_alliance_data(doc);
	            	
	        if (alliance_text != false) {
	            var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"allyhistory",alliance_text,alliance_text_xml,doc.location.href);
	        } else {
		        eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 3, "No data found");
		    }
	}	
}
