if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_init) eu.galaxytool.GTPlugin_init={};

window.addEventListener("load", function(){ eu.galaxytool.GTPlugin_init.init(); }, false);

eu.galaxytool.GTPlugin_init = {
    init: function() {
    	eu.galaxytool.GTPlugin_general.Prefs = eu.galaxytool.GTPlugin_general.getPrefs();
    	eu.galaxytool.GTPlugin_storage.initStorage();
    	
    	// check if an update is needed and run update
		eu.galaxytool.GTPlugin_general.update_check();
    	
        try {
        	if (typeof fg_HookFunctionNoRegexp == "function") {
        		fg_HookFunctionNoRegexp(this.onPageDomLoadCont);
        	} else {
        	    var appcontent = document.getElementById("appcontent");   // browser
    	        if(appcontent) 
	            appcontent.addEventListener("load", this.onPageLoad, true);
        	}
        } catch(e) {
            // nothing
            // alert("error:"+e);
        }
        try {
            var messagepane = document.getElementById("messagepane"); // mail
            if(messagepane)
            messagepane.addEventListener("load", this.onPageLoad, true);
        } catch(e) {
            // nothing
            // alert("error:"+e);
        }
        try {
        	if (typeof fg_HookFunctionNoRegexp == "function") {
        		fg_HookFunctionNoRegexp(this.onPageLoadCont);
        	} else {
	        	window.addEventListener('DOMContentLoaded', this.onPageDomLoad, true);
        	}
        } catch(e) {
        	// alert("DOMContentLoad-error: "+e);
        }
        
        
    },
    
    onPageDomLoad: function(aEvent) {
		var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
        eu.galaxytool.GTPlugin_init.onPageDomLoadCont(doc);
	},
	        
	onPageDomLoadCont: function(doc) {
		// use this event for the galaxyview page instead of page load (caused problems sometimes)
		// get debugsettings
    	try {				    	
			eu.galaxytool.GTPlugin_general.Prefs = eu.galaxytool.GTPlugin_general.getPrefs();
			if (eu.galaxytool.GTPlugin_general.Prefs.getBoolPref("gtplugin.settings.debug") == true) {
				eu.galaxytool.GTPlugin_general.debug_mode = true;
			} else {
				eu.galaxytool.GTPlugin_general.debug_mode = false;
			}
    	} catch (error) {
    	// prefs haven't been set yet
    	}
		
        var text;
        // do something with the loaded page.
        // doc.location is a Location object (see below for a link).
        try {
            if ((doc.location.href.toString().search("/game/index.php") > -1) && (doc.location.href.toString().search("page=galaxy") > -1)) { // /game/galaxy.php
            	if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"galaxy") == true) {
					
					eu.galaxytool.GTPlugin_init.update_universe_at_settings(doc);
					
					// update Messagedoc within the eventlistener-function, so when opening an espionage report in an iframe, the MessageDoc won't be lost
					// and we don't get an exception, when trying to create a status tab, without having the recent messagedoc
					doc.getElementById('galaxyContent').addEventListener("DOMNodeInserted", 
							function(e){ 
								try {
									//added the check here, just to avoid multiple, unnecessary updates of the Messagedoc
									var id = e.relatedNode.getAttributeNode("id").value;
									if (id != "galaxyContent") {
										return;
									}
									eu.galaxytool.GTPlugin_general.Messagedoc = doc;
									eu.galaxytool.GTPlugin_galaxyview.submit_galaxydata(e); 
								} catch (e) {
									return;
								} 
							}, false );
										
            	}

            }
            
           // Allyhistory
            if ((doc.location.href.toString().search("/game/index.php") > -1) &&(doc.location.href.toString().search("page=alliance") > -1)) {
				if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"allypage") == true) {
					eu.galaxytool.GTPlugin_general.Messagedoc = doc;
					eu.galaxytool.GTPlugin_init.update_universe_at_settings(doc);
					doc.getElementById('eins').addEventListener("DOMNodeInserted", function(e){ eu.galaxytool.GTPlugin_allypage.submit_allydata(e); }, false );
	            	
				}
            	
            }  
        
            // Empire view
            if ((doc.location.href.toString().search("/game/index.php") > -1) &&(doc.location.href.toString().search("page=empire") > -1)) {
				if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"empire") == true) {
					eu.galaxytool.GTPlugin_general.Messagedoc = doc;
					eu.galaxytool.GTPlugin_init.update_universe_at_settings(doc);
					
					doc.getElementById('mainWrapper').addEventListener("DOMNodeInserted", function(e){ eu.galaxytool.GTPlugin_empire.submit_empiredata(e); }, false );
				}
            }  
        } catch(error) {
            // nothing to do
            // alert("error2: "+error);
        }
    
    },

	onPageLoad: function(aEvent) {
		var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
		eu.galaxytool.GTPlugin_init.onPageLoadCont(doc);
	},
	
    onPageLoadCont: function(doc) {
    	try {
    		if (doc.location.href.toString().search("/game/index.php") > -1) {
	            // all ogame pages - add playername to link to empire view (if it exists)
	            try {
	            	eu.galaxytool.GTPlugin_empire.set_playername(doc.getElementById("playerName").getElementsByTagName("span")[0].innerHTML, doc.location.href.toString());
			    } catch(e) {
	            	// do nothing
			    }
    		}
    		
    		if ((doc.location.href.toString().search("/game/index.php") > -1) && (
    	     (doc.location.href.toString().search("page=statistics") > -1) ||
    	     (doc.location.href.toString().search("page=messages") > -1) ||
    	     (doc.location.href.toString().search("page=showmessage") > -1) ||
    	     (doc.location.href.toString().search("page=shipyard") > -1) ||
    	     (doc.location.href.toString().search("page=resources") > -1) ||
    	     (doc.location.href.toString().search("page=station") > -1) ||
    	     (doc.location.href.toString().search("page=defense") > -1) ||
    	     (doc.location.href.toString().search("page=research") > -1) ||
    	     (doc.location.href.toString().search("page=overview") > -1) ||
    	     (doc.location.href.toString().search("page=empire") > -1) )) { 
    		
    			eu.galaxytool.GTPlugin_init.update_universe_at_settings(doc);
    			// alert("Universe should be updated at settings - href: "+doc.location.href.toString());
    		}
    	} catch(e) {
    		// alert("Error when trying to update Universe at settings - href: "+doc.location.href.toString()+" error: "+e);
    		// some pages (e.g. report iframe) have no TITLE tag - this is catched here
    	}
    	
		// get debugsettings
		try {
			eu.galaxytool.GTPlugin_general.Prefs = eu.galaxytool.GTPlugin_general.getPrefs();
			if (eu.galaxytool.GTPlugin_general.Prefs.getBoolPref("gtplugin.settings.debug") == true) {
				eu.galaxytool.GTPlugin_general.debug_mode = true;
			} else {
				eu.galaxytool.GTPlugin_general.debug_mode = false;
			}
			
	        var text;
	        // do something with the loaded page.
	        // doc.location is a Location object (see below for a link).
        
            if ((doc.location.href.toString().search("/game/index.php") > -1) && (doc.location.href.toString().search("page=statistics") > -1)) {
            	if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"stats") == true) {
					eu.galaxytool.GTPlugin_stats.Messagedoc = doc;
					doc.getElementById('statisticsContent').addEventListener("DOMNodeInserted", function(e){ eu.galaxytool.GTPlugin_stats.submit_statsdata(e); }, false );
            	}
            }
            
            // overall message view - reports can be part of it
            if ((doc.location.href.toString().search("index.php") > -1) && (doc.location.href.toString().search("page=messages") > -1)) {
                eu.galaxytool.GTPlugin_general.Messagedoc = doc;
            }            
            
            // single message view (iframe) - reports
            if ((doc.location.href.toString().search("index.php") > -1) && (doc.location.href.toString().search("page=showmessage") > -1)) {
            	if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"reports") == true) {
	                eu.galaxytool.GTPlugin_general.Messagedoc = doc;
            		eu.galaxytool.GTPlugin_reports.findSingleReport();
            	}

            }
               


            if (doc.location.href.toString().search("/game/index.php") > -1) {
	            // do not read Fleet menu -> too much traffic (on each fleet sendings)
	            
	            // shipyard
                if (doc.location.href.toString().search("page=shipyard") > -1) {
                	if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"fleet") == true) {
		               	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, "Shipyard page found");
		               	var data = eu.galaxytool.GTPlugin_planet_data.getData(doc,"military",null,false); // military = ID to look for
		               	var data2,data2_xml;
		               	[data2,data2_xml] = eu.galaxytool.GTPlugin_planet_data.getData(doc,"civil",data,true); // civil = ID to look for
		               	//alert(data2_xml);
		               	data2 = data2.replace(/civil/g, "fleet"); // workaround for 4.3.7
		               	if (data2 != "") {
		               		var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"fleet",data2,data2_xml,doc.location.href);
	               		} else {
		                	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 3, "No data found");	
		                }
                	}
	            }	            
	            
	            // resources buildings
                if (doc.location.href.toString().search("page=resources") > -1) {
					if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"buildings") == true) {
		               	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, "Building page found");
		               	var data = eu.galaxytool.GTPlugin_planet_data.getData(doc,"building",null,false); // building = ID to look for
		               	var data2,data2_xml;
		               	[data2,data2_xml] = eu.galaxytool.GTPlugin_planet_data.getData(doc,"storage",data,true); // storage = ID to look for
		               	//alert(data2_xml);
		               	data2 = data2.replace(/storage/g, "buildings"); // workaround for 4.3.7
		               	if (data != "") {
		               		var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"buildings",data2,data2_xml,doc.location.href);
	               		} else {
		                	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 3, "No data found");	
		                }
                	}
	            }
	            
	            // facilities
                if (doc.location.href.toString().search("page=station") > -1) {
					if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"buildings") == true) {
		               	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, "Building page found");
		               	var data,data_xml;
		               	[data,data_xml] =  eu.galaxytool.GTPlugin_planet_data.getData(doc,"stationbuilding",null,true); // stationbuilding = ID to look for
		               	//alert(data_xml);
		               	data = data.replace(/stationbuilding/g, "buildings"); // workaround for 4.3.7
		               	if (data != "") {
		               		var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"buildings",data,data_xml,doc.location.href);
	               		} else {
		                	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 3, "No data found");	
		                }
                	}
	            }
	
				// defense
	            if (doc.location.href.toString().search("page=defense") > -1) {
					if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"defense") == true) {
	                	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, "Defense page found");
	                	var data,data_xml;
		               	[data,data_xml] = eu.galaxytool.GTPlugin_planet_data.getData(doc,"defensebuilding",null,true);
		               	//alert(data_xml);
	                	data = data.replace(/defensebuilding/g, "defense"); // workaround for 4.3.7
	                	if (data != "") {
	                		var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"defense",data,data_xml,doc.location.href);
	                	} else {
	                		eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 3, "No data found");	
	               	 	}
            		}
	            }
	            
	            // research
	            if (doc.location.href.toString().search("page=research") > -1) {
					if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"research") == true) {
		                eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, "Tech page found");
		                try {
		               	// abuse this value too
		               	eu.galaxytool.GTPlugin_general.Messagedoc = doc;

		               	var data = eu.galaxytool.GTPlugin_planet_data.getData(doc,"base",null,false); // null, false !!!
		               	var data2 = eu.galaxytool.GTPlugin_planet_data.getData(doc,"base2",data,false);
		               	var data3 = eu.galaxytool.GTPlugin_planet_data.getData(doc,"base3",data2,false);
		               	var data4,data4_xml;
		               	[data4,data4_xml] = eu.galaxytool.GTPlugin_planet_data.getData(doc,"base4",data3,true);
		                //alert(data4_xml);
		                if (data4 != "") {
		                	var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"techs",data4,data4_xml,doc.location.href);
	            		} else {
	                		eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 3, "No data found");	
	                	}
		                } catch(my_error) {
		                	// alert("my error: "+my_error);
		                }
            		}
	            } 
	            
	            // read all Techs
	            if (doc.location.href.toString().search("page=globalTechtree") > -1) {
		            if (eu.galaxytool.GTPlugin_storage.target_tool_exists(doc.location.href,"reports") == true) {            	
		            		eu.galaxytool.GTPlugin_general.set_status(doc,"galaxyplugin"+1,0,"Techtree found");
							if(eu.galaxytool.GTPlugin_techtreeparser.parse_techtree(doc)) {
								eu.galaxytool.GTPlugin_general.set_status(doc,"galaxyplugin"+1,1,"Techtree parsed")
							} else {
								eu.galaxytool.GTPlugin_general.set_status(doc,"galaxyplugin"+1,3,"Techtree not parsed")
							}			
		            }
	            }
				
            }

        } catch(error) {
            // nothing to do
            // alert("error: "+error);
        }


    },
    
	update_universe_at_settings: function(doc) {
		// Universe number or name
	    var GTPlugin_Universe = eu.galaxytool.GTPlugin_general.getUniverse(doc);
	    // update this at the read only field "universe" at options
	    // not necessary from v2.3
	    /*
	    eu.galaxytool.GTPlugin_general.Prefs = eu.galaxytool.GTPlugin_general.getPrefs();
		if (eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl1") != "" && doc.location.href.search(eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl1")) > -1) {
			eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.ogameuni1", decodeURIComponent(GTPlugin_Universe)); // set a pref
		}
		if (eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl2") != "" && doc.location.href.search(eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl2")) > -1) {
			eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.ogameuni2", decodeURIComponent(GTPlugin_Universe)); // set a pref
		}
		if (eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl3") != "" && doc.location.href.search(eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl3")) > -1) {
			eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.ogameuni3", decodeURIComponent(GTPlugin_Universe)); // set a pref
		}
		if (eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl4") != "" && doc.location.href.search(eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl4")) > -1) {
			eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.ogameuni4", decodeURIComponent(GTPlugin_Universe)); // set a pref
		}
		if (eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl5") != "" && doc.location.href.search(eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.ogameurl5")) > -1) {
			eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.ogameuni5", decodeURIComponent(GTPlugin_Universe)); // set a pref
	    }
	    */
	    
	    // update this at the read only field "universe" at options - new version
	    eu.galaxytool.GTPlugin_storage.update_universe_for_ogame_url(doc.location.href,GTPlugin_Universe);
		
	}
   
}

