if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_galaxyview) eu.galaxytool.GTPlugin_empire={};


eu.galaxytool.GTPlugin_empire = {
	
	playername: new Array(),
	
	get_empire_data: function(docroot,playername) {
		var i = 0;
		var j = 0;
		var k = 0;
		var l = 0;
		var classname = null;
		var moon = null;
        var empire_xml = "";
        
	    try {
	    	if (docroot.location.href.toString().search("planetType=1") > -1) {
	    		moon = "true";
	    	} else {
	    		moon = "false";
	    	}
	    	
			var div = docroot.getElementById('mainWrapper');
	    } catch(e) {
	        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Unexpected error: no empire table found");
	        return false;
	        // nothing to do
	    }
	    

	    try {
			i = 0;
			var current_div = null;
			var planets_div = null;
			while(current_div = div.getElementsByTagName('div')[i]) {
				try {
					if (current_div.getAttributeNode("class").value.indexOf("planetWrapper") > -1) {
						planets_div = current_div;
						break;
					}
				} catch(e) {
					// ignore exceptions for non existing class attribute
				}
				i++;
			}		    
	    } catch(e) {
	        // nothing to do
	    }
	    if (planets_div == null) {
	    	return false;
	    }
	    
	    
	    try {
	    	var details_div = null;
	    	var planets = 0;
			
			planets = planets_div.childNodes.length;
	    	var planetheader  = new Array(planets);
	    	var resources     = new Array(planets);
	    	var res_buildings = new Array(planets);
	    	var facilities    = new Array(planets);
	    	var defence       = new Array(planets);
	    	var research      = new Array(planets);
	    	var fleet         = new Array(planets);
	    	
	    	for (i=0;i<planetheader.length;i++)  planetheader[i]  = new Array(2);
	    	for (i=0;i<resources.length;i++)     resources[i]     = new Array(3);
	    	for (i=0;i<res_buildings.length;i++) res_buildings[i] = new Array(8);
	    	for (i=0;i<facilities.length;i++)    facilities[i]    = new Array(7);
	    	for (i=0;i<defence.length;i++)       defence[i]       = new Array(10);
	    	for (i=0;i<research.length;i++)      research[i]      = new Array(16);
	    	for (i=0;i<fleet.length;i++)         fleet[i]         = new Array(14);
	    	
	    	// Loop all planets or moons
	    	var planets = 0;
	    	for (i=0; i<planets_div.childNodes.length; i++) {
	    		current_div = planets_div.childNodes[i];
	    		try {
	    			classname = current_div.getAttributeNode("class").value;
	    		} catch(e) {
	    			classname = null;
	    		}
	    		if (classname == "planet") {
	    			// loop planet information
	    			for (j=0; j<current_div.childNodes.length; j++) {
	    				details_div = current_div.childNodes[j];
			    		try {
			    			classname = details_div.getAttributeNode("class").value;
			    		} catch(e) {
			    			classname = null;
			    		}
						
						// sequence of ships, buildings etc is always the same. Buildings that do not exist yet are shown anyway
						if (classname == "planetHead") {
			    			for (k=0; k<details_div.childNodes.length; k++) {
			    				var tmp = details_div.childNodes[k];
					    		try {
					    			var tmp_class = tmp.getAttributeNode("class").value;
					    		} catch(e) {
					    			var tmp_class = null;
					    		}			    				
			    				if(tmp_class == "planetname") {
			    					// planetname
			    					planetheader[i][0] = tmp.innerHTML;
			    				} else if(tmp_class == "planetData") {
			    					// coordinates
			    					planetheader[i][1] = tmp.getElementsByTagName('li')[0].getElementsByTagName('a')[0].innerHTML.replace(/[\[\]]/g,"");
			    				}
			    			}
							
							
						} else if (classname.indexOf("groupresources") > -1) { // resources
							for (l=0;l<3;l++) {
								resources[i][l] = details_div.getElementsByTagName('div')[l].getElementsByTagName('span')[0].innerHTML.replace(/[^0-9]/g,"");
								if(resources[i][l] == "") resources[i][l] = 0;
							}
						} else if (classname.indexOf("groupsupply") > -1 && moon == "false") {    // resource buildings
							for (l=0;l<8;l++) {
								res_buildings[i][l] = details_div.getElementsByTagName('div')[l].getElementsByTagName('a')[0].innerHTML.replace(/[^0-9]/g,"");
								if(res_buildings[i][l] == "") res_buildings[i][l] = 0;
							}
						
						} else if (classname.indexOf("groupstation") > -1) {   // facilities
							if (moon == "true") {
								for (l=0;l<5;l++) {
									facilities[i][l] = details_div.getElementsByTagName('div')[l].getElementsByTagName('a')[0].innerHTML.replace(/[^0-9]/g,"");
									if(facilities[i][l] == "") facilities[i][l] = 0;
								}
							} else {
								for (l=0;l<7;l++) {
									facilities[i][l] = details_div.getElementsByTagName('div')[l].getElementsByTagName('a')[0].innerHTML.replace(/[^0-9]/g,"");
									if(facilities[i][l] == "") facilities[i][l] = 0;
								}
							}
						
						} else if (classname.indexOf("groupdefence") > -1) {   // defence - no information about defence in progress
							for (l=0;l<10;l++) {
								defence[i][l] = details_div.getElementsByTagName('div')[l].innerHTML.replace(/[^0-9]/g,"");
								if(defence[i][l] == "") defence[i][l] = 0;
							}
						
						} else if (classname.indexOf("groupresearch") > -1) {  // research
							for (l=0;l<16;l++) {
								research[i][l] = parseInt(details_div.getElementsByTagName('div')[l].innerHTML); // parseInt will remove also the new tech that might be next to current tech
							}
						
						} else if (classname.indexOf("groupships") > -1) {     // ships - no information about ships in progress
							for (l=0;l<14;l++) {
								fleet[i][l] = details_div.getElementsByTagName('div')[l].innerHTML.replace(/[^0-9]/g,"");
								if(fleet[i][l] == "") fleet[i][l] = 0;
							}
						}								
						
						    				
	    				
	    			}
	    			
	    			
	    			
	    		} // ignore all other classes that might come up
	    		
	    		
	    		planets++;
	    	}
            	    
            	    
           	// create XML
			var date_now = new Date();
			var year   = date_now.getFullYear();		
			var month  = date_now.getMonth()+1; // 0 = January		
			var day    = date_now.getDate();	
			var hour   = date_now.getHours();		
			var minute = date_now.getMinutes();		
			var second = date_now.getSeconds();
			
			if (month < 10)  month  = "0"+month;
			if (day < 10)    day    = "0"+day;
			if (hour < 10)   hour   = "0"+hour;
			if (minute < 10) minute = "0"+minute;
			if (second < 10) second = "0"+second;
			
			for (i=0;i<planetheader.length;i++) {
				var report_xml = "";
				if (planetheader[i][1] != "") {
					var coords_exp = /(\d+):(\d+):(\d+)/;
					var coords = coords_exp.exec(planetheader[i][1]);
					var galaxy = coords[1];
					var system = coords[2];
					var planet = coords[3];
					
					// report "header"
					report_xml = '	<report playername="'+playername+'" planetname="'+planetheader[i][0]+'" moon="'+moon+'" galaxy="'+galaxy+'" system="'+system+'" planet="'+planet+'" ';
					report_xml += 'datetime="'+year+'.'+month+'.'+day+' '+hour+':'+minute+':'+second+'" scandepth="research">'+'\n'; 
					
					// report "body"
					// resources
					// Energy can't be obtained at the moment (OGame v1.3.0)
					report_xml += '		<entry name="Metal" amount="'+resources[i][0]+'"/>'+'\n';
					report_xml += '		<entry name="Crystal" amount="'+resources[i][1]+'"/>'+'\n';
					report_xml += '		<entry name="Deuterium" amount="'+resources[i][2]+'"/>'+'\n';
					report_xml += '		<entry name="Energy" amount="0"/>'+'\n';
					
					// fleet (14)
					report_xml += '		<entry name="Small Cargo" amount="'+fleet[i][0]+'"/>'+'\n';
					report_xml += '		<entry name="Large Cargo" amount="'+fleet[i][1]+'"/>'+'\n';
					report_xml += '		<entry name="Light Fighter" amount="'+fleet[i][2]+'"/>'+'\n';
					report_xml += '		<entry name="Heavy Fighter" amount="'+fleet[i][3]+'"/>'+'\n';
					report_xml += '		<entry name="Cruiser" amount="'+fleet[i][4]+'"/>'+'\n';
					report_xml += '		<entry name="Battleship" amount="'+fleet[i][5]+'"/>'+'\n';
					report_xml += '		<entry name="Colony Ship" amount="'+fleet[i][6]+'"/>'+'\n';
					report_xml += '		<entry name="Recycler" amount="'+fleet[i][7]+'"/>'+'\n';
					report_xml += '		<entry name="Espionage Probe" amount="'+fleet[i][8]+'"/>'+'\n';
					report_xml += '		<entry name="Bomber" amount="'+fleet[i][9]+'"/>'+'\n';
					report_xml += '		<entry name="Solar Satellite" amount="'+fleet[i][10]+'"/>'+'\n';
					report_xml += '		<entry name="Destroyer" amount="'+fleet[i][11]+'"/>'+'\n';
					report_xml += '		<entry name="Deathstar" amount="'+fleet[i][12]+'"/>'+'\n';
					report_xml += '		<entry name="Battlecruiser" amount="'+fleet[i][13]+'"/>'+'\n';
					
					// defense (10)
					report_xml += '		<entry name="Rocket Launcher" amount="'+defence[i][0]+'"/>'+'\n';
					report_xml += '		<entry name="Light Laser" amount="'+defence[i][1]+'"/>'+'\n';
					report_xml += '		<entry name="Heavy Laser" amount="'+defence[i][2]+'"/>'+'\n';
					report_xml += '		<entry name="Gauss Cannon" amount="'+defence[i][3]+'"/>'+'\n';
					report_xml += '		<entry name="Ion Cannon" amount="'+defence[i][4]+'"/>'+'\n';
					report_xml += '		<entry name="Plasma Turret" amount="'+defence[i][5]+'"/>'+'\n';
					report_xml += '		<entry name="Small Shield Dome" amount="'+defence[i][6]+'"/>'+'\n';
					report_xml += '		<entry name="Large Shield Dome" amount="'+defence[i][7]+'"/>'+'\n';
					report_xml += '		<entry name="Anti-Ballistic Missiles" amount="'+defence[i][8]+'"/>'+'\n';
					report_xml += '		<entry name="Interplanetary Missiles" amount="'+defence[i][9]+'"/>'+'\n';
					
					if (moon == "false") {
						// resource buildings (8)
						report_xml += '		<entry name="Metal Mine" amount="'+res_buildings[i][0]+'"/>'+'\n';
						report_xml += '		<entry name="Crystal Mine" amount="'+res_buildings[i][1]+'"/>'+'\n';
						report_xml += '		<entry name="Deuterium Synthesizer" amount="'+res_buildings[i][2]+'"/>'+'\n';
						report_xml += '		<entry name="Solar Plant" amount="'+res_buildings[i][3]+'"/>'+'\n';
						report_xml += '		<entry name="Fusion Reactor" amount="'+res_buildings[i][4]+'"/>'+'\n';
						report_xml += '		<entry name="Metal Storage" amount="'+res_buildings[i][5]+'"/>'+'\n';
						report_xml += '		<entry name="Crystal Storage" amount="'+res_buildings[i][6]+'"/>'+'\n';
						report_xml += '		<entry name="Deuterium Tank" amount="'+res_buildings[i][7]+'"/>'+'\n';
						
						// facilities (7)
						report_xml += '		<entry name="Robotics Factory" amount="'+facilities[i][0]+'"/>'+'\n';
						report_xml += '		<entry name="Nanite Factory" amount="'+facilities[i][1]+'"/>'+'\n';
						report_xml += '		<entry name="Shipyard" amount="'+facilities[i][2]+'"/>'+'\n';
						report_xml += '		<entry name="Research Lab" amount="'+facilities[i][3]+'"/>'+'\n';
						report_xml += '		<entry name="Terraformer" amount="'+facilities[i][4]+'"/>'+'\n';
						report_xml += '		<entry name="Alliance Depot" amount="'+facilities[i][5]+'"/>'+'\n';
						report_xml += '		<entry name="Missile Silo" amount="'+facilities[i][6]+'"/>'+'\n';
					} else {
						// moon has only facilities
						report_xml += '		<entry name="Robotics Factory" amount="'+facilities[i][0]+'"/>'+'\n';
						report_xml += '		<entry name="Shipyard" amount="'+facilities[i][1]+'"/>'+'\n';
						report_xml += '		<entry name="Lunar Base" amount="'+facilities[i][2]+'"/>'+'\n';
						report_xml += '		<entry name="Sensor Phalanx" amount="'+facilities[i][3]+'"/>'+'\n';
						report_xml += '		<entry name="Jump Gate" amount="'+facilities[i][4]+'"/>'+'\n';
					}
					
					// research (16)
					report_xml += '		<entry name="Espionage Technology" amount="'+research[i][0]+'"/>'+'\n';
					report_xml += '		<entry name="Computer Technology" amount="'+research[i][1]+'"/>'+'\n';
					report_xml += '		<entry name="Weapons Technology" amount="'+research[i][2]+'"/>'+'\n';
					report_xml += '		<entry name="Shielding Technology" amount="'+research[i][3]+'"/>'+'\n';
					report_xml += '		<entry name="Armour Technology" amount="'+research[i][4]+'"/>'+'\n';
					report_xml += '		<entry name="Energy Technology" amount="'+research[i][5]+'"/>'+'\n';
					report_xml += '		<entry name="Hyperspace Technology" amount="'+research[i][6]+'"/>'+'\n';
					report_xml += '		<entry name="Combustion Drive" amount="'+research[i][7]+'"/>'+'\n';
					report_xml += '		<entry name="Impulse Drive" amount="'+research[i][8]+'"/>'+'\n';
					report_xml += '		<entry name="Hyperspace Drive" amount="'+research[i][9]+'"/>'+'\n';
					report_xml += '		<entry name="Laser Technology" amount="'+research[i][10]+'"/>'+'\n';
					report_xml += '		<entry name="Ion Technology" amount="'+research[i][11]+'"/>'+'\n';
					report_xml += '		<entry name="Plasma Technology" amount="'+research[i][12]+'"/>'+'\n';
					report_xml += '		<entry name="Intergalactic Research Network" amount="'+research[i][13]+'"/>'+'\n';
					report_xml += '		<entry name="Astrophysics" amount="'+research[i][14]+'"/>'+'\n';
					report_xml += '		<entry name="Graviton Technology" amount="'+research[i][15]+'"/>'+'\n';
	    						
	    			// close report "header"
	    			report_xml += '	</report>'+'\n';
	    			
	    			empire_xml += report_xml;
				}
				
			}
		
			return empire_xml;
	    
	    } catch(error) {
	    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Unexpected error: "+error);
	    	return false;
	        // nothing to do
	    }
	    
	},
	
	
	submit_empiredata: function(e) {
		try {
			var id = e.relatedNode.getAttributeNode("id").value;
			if (id != "mainWrapper") {
				return;
			}	
			
			try {
				if (e.target.getAttributeNode("id").value != "total") {
					// div id="total" is the last object inserted into mainWrapper which is relevant for parsing
					return;
				}
			} catch(e) {
				// ID attribute does not exist
				return;
			}
			// now we found HTML content that contained the ID
			
			doc = eu.galaxytool.GTPlugin_general.Messagedoc;
			var playername = eu.galaxytool.GTPlugin_empire.get_playername(doc.location.href.toString());
			if (playername != "") {
	          	var data = "";
	           	var data_xml = eu.galaxytool.GTPlugin_empire.get_empire_data(doc,playername);
	           	if (data_xml != false) {
	           		var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"reports",data,data_xml,doc.location.href);
	           	}
			}
			
						
		} catch(e) {
			// do nothing
			//alert("error: "+e);
		}	
	},
	
	set_playername: function(playername, url) {
		
		try {
			if (url.indexOf(".php") > -1) {
				url = url.substring(0,url.indexOf(".php")+4);
			}
			
			if (eu.galaxytool.GTPlugin_empire.get_playername(url) != "") {
				for (i=0; i<eu.galaxytool.GTPlugin_empire.playername.length;i++){
					if (url == eu.galaxytool.GTPlugin_empire.playername[i]["url"]) {
						eu.galaxytool.GTPlugin_empire.playername[i]["name"] = playername;
					}
				}
			} else {
				var array_index = eu.galaxytool.GTPlugin_empire.playername.length;
				eu.galaxytool.GTPlugin_empire.playername[array_index] = new Object();
				eu.galaxytool.GTPlugin_empire.playername[array_index]["name"]	= playername;
				eu.galaxytool.GTPlugin_empire.playername[array_index]["url"] 	= url;
			}
		
		} catch(e) {
			// do nothing
		}
	},
	
	get_playername: function(url) {
		var i;
		
		try {
			if (url.indexOf(".php") > -1) {
				url = url.substring(0,url.indexOf(".php")+4);
			}
			
			for (i=0; i<eu.galaxytool.GTPlugin_empire.playername.length;i++){
				if (url == eu.galaxytool.GTPlugin_empire.playername[i]["url"]) {
					return eu.galaxytool.GTPlugin_empire.playername[i]["name"];
				}
			}
			return "";
		} catch(e) {
			return "";
		}		
	}
	
}