if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_techtreeparser) eu.galaxytool.GTPlugin_techtreeparser={};

eu.galaxytool.GTPlugin_techtreeparser = {
	
	parse_techtree: function(doc) {	
	 	try {
			var tech_ids = new Array();
			var translated_tech_names = new Array();
			var td;
			var i = 0;
			var tmp;
			while (td = doc.getElementById("techinfo").getElementsByTagName("td")[i]) {
				i++;
				try {
					if(td.getAttributeNode("class").value == "item") {
						tmp = td.getElementsByTagName("img")[0].getAttributeNode("src").value;
						tmp = tmp.replace("img/tiny/tiny_","");
						tmp = tmp.replace(".jpg","");
						tech_ids.push(parseInt(tmp));
						translated_tech_names.push(eu.galaxytool.GTPlugin_general.trimString(td.getElementsByTagName("a")[0].innerHTML));
					}
				} catch (no_error) {
					//not each td has a class attribute
				}
			}
			
			var english_technames = eu.galaxytool.GTPlugin_planet_data.translate_techids_to_english(tech_ids);
			
			var tool_ids = eu.galaxytool.GTPlugin_storage.read_tool_ids_for_ogame_url(doc.location.href);
			
			if (tool_ids.length > 0) {
			return eu.galaxytool.GTPlugin_storage.insert_translations(tool_ids,english_technames,translated_tech_names);
			}
			
			return false;
	 	} catch(error) {
	 		alert("Unexpected error while parsing techtree: "+error);
	 		return false;
	 	}	
	}
	
	

}